您的位置:首页 > 其它

【Codeforces Round 362 (Div 2)D】

2017-07-05 15:33 260 查看
Description

Barney lives in country USC (United States of Charzeh). USC has n cities numbered from 1 through n and n - 1 roads between them. Cities and roads of USC form a rooted tree (Barney’s not sure why it is rooted). Root of the tree is the city number 1. Thus if one will start his journey from city 1, he can visit any city he wants by following roads.


This picture is so amazing~~

Some girl has stolen Barney’s heart, and Barney wants to find her. He starts looking for in the root of the tree and (since he is Barney Stinson not a random guy), he uses a random DFS to search in the cities. A pseudo code of this algorithm is as follows:

let starting_time be an array of length n

current_time = 0

dfs(v):

current_time = current_time + 1

starting_time[v] = current_time

shuffle children[v] randomly (each permutation with equal possibility)

// children[v] is vector of children cities of city v

for u in children[v]:

dfs(u)

As told before, Barney will start his journey in the root of the tree (equivalent to call dfs(1)).

Now Barney needs to pack a backpack and so he wants to know more about his upcoming journey: for every city i, Barney wants to know the expected value of starting_time[i]. He’s a friend of Jon Snow and knows nothing, that’s why he asked for your help.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 105) — the number of cities in USC.

The second line contains n - 1 integers p2, p3, …, pn (1 ≤ pi < i), where pi is the number of the parent city of city number i in the tree, meaning there is a road between cities numbered pi and i in USC.

Output

In the first and only line of output print n numbers, where i-th number is the expected value of starting_time[i].

Your answer for each city will be considered correct if its absolute or relative error does not exceed 10 - 6.

Sample Input

Input

7

1 2 1 1 4 4

Output

1.0 4.0 5.0 3.5 4.5 5.0 5.0

Input

12

1 1 2 2 4 4 3 3 1 10 8

Output

1.0 5.0 5.5 6.5 7.5 8.0 8.0 7.0 7.5 6.5 7.5 8.0

思路:

到达某一点所需要的步数期望为其父节点步数期望加一在加上其兄弟节点树的大小/2.0。因为,从父节点到此节点和不到此节点的概率相等均为1/2;

#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;
int n,sz[100009];
double ans[100009];
vector<int> mp[100099];
void dfs1(int x)//计算以x为根的树的大小
{
sz[x]=0;
for(int i=0;i<mp[x].size();i++)
{
int y=mp[x][i];
dfs1(y);
sz[x]+=sz[y];
}
sz[x]++;
}
void dfs2(int x)
{
for(int i=0;i<mp[x].size();i++)
{
int y=mp[x][i];
int sum=sz[x]-sz[y]-1;//兄弟树的大小
ans[y]=ans[x]+1+sum/2.0;
dfs2(y);
}
}
int main()
{
scanf("%d",&n);
for(int i=2;i<=n;i++)
{
int x;
scanf("%d",&x);
mp[x].push_back(i);
}
dfs1(1);
ans[1]=1.0;
dfs2(1);
for(int i=1;i<=n;i++)
printf("%.1f ",ans[i]);
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: 
相关文章推荐